package org.minecms.dyneco;

import java.io.File;
import java.io.InputStream;
import java.sql.*;
import java.util.logging.Logger;

import net.milkbowl.vault.economy.Economy;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.RegisteredServiceProvider;
import org.bukkit.plugin.java.JavaPlugin;

public class DynEco extends JavaPlugin {
	final Logger LOGGER = Logger.getLogger("Minecraft");
	public Economy economy = null;
	public CommandHandler commandHandler;
	public ItemDb itemdb;
	private YamlConfiguration itemValues;
	Connection mysql = null;
	Statement mysqlStmt = null;
	EconomyHandler ecoHandler;

	public DynEco() {

	}

	@Override
	public void onDisable() {
		LOGGER.info("[DynEco] Disabled");
	}

	public void reload() {
		File file = new File(getDataFolder(), "value.yml");
		itemValues = YamlConfiguration.loadConfiguration(file);

		InputStream defaultValue = getResource("value.yml");
		if (defaultValue != null) {
			YamlConfiguration defConfig = YamlConfiguration
					.loadConfiguration(defaultValue);
			itemValues.setDefaults(defConfig);
		}
		RegisteredServiceProvider<Economy> economyProvider = getServer()
				.getServicesManager().getRegistration(
						net.milkbowl.vault.economy.Economy.class);
		if (economyProvider != null) {
			economy = economyProvider.getProvider();
		}

		try {
			Class.forName("com.mysql.jdbc.Driver");
		} catch (Exception e) {
			e.printStackTrace();
		}
		this.reloadConfig();
		FileConfiguration cfg = getConfig();

		String address = "jdbc:mysql://" + cfg.getString("mysql.address") + ":"
				+ cfg.getString("mysql.port") + "/"
				+ cfg.getString("mysql.database");
		LOGGER.info("[DynEco] Connecting to MySQL server: " + address);
		try {
			mysql = DriverManager.getConnection(address,
					cfg.getString("mysql.user"), cfg.getString("mysql.pass"));
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			mysqlStmt = mysql.createStatement();

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			LOGGER.info("[DynEco] Connected");
		}
		LOGGER.info("[DynEco] Enabled");
	}

	@Override
	public void onEnable() {

		getConfig().options().copyDefaults(true);
		File file = new File(getDataFolder(), "value.yml");
		itemValues = YamlConfiguration.loadConfiguration(file);
		InputStream defaultValue = getResource("value.yml");
		if (defaultValue != null) {
			YamlConfiguration defConfig = YamlConfiguration
					.loadConfiguration(defaultValue);
			itemValues.setDefaults(defConfig);
		}
		itemdb = new ItemDb(this);
		final PluginManager pm = getServer().getPluginManager();

		DynEcoPlayerListener playerListener = null;
		try {
			playerListener = new DynEcoPlayerListener(this);
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		pm.registerEvents(playerListener, this);
		RegisteredServiceProvider<Economy> economyProvider = getServer()
				.getServicesManager().getRegistration(
						net.milkbowl.vault.economy.Economy.class);
		if (economyProvider != null) {
			economy = economyProvider.getProvider();
		}

		try {
			Class.forName("com.mysql.jdbc.Driver");
		} catch (Exception e) {
			e.printStackTrace();
		}
		FileConfiguration cfg = getConfig();

		String address = "jdbc:mysql://" + cfg.getString("mysql.address") + ":"
				+ cfg.getString("mysql.port") + "/"
				+ cfg.getString("mysql.database");
		LOGGER.info("[DynEco] Connecting to MySQL server: " + address);
		try {
			mysql = DriverManager.getConnection(address,
					cfg.getString("mysql.user"), cfg.getString("mysql.pass"));
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			LOGGER.severe("[DynEco] Can not connect to MySQL database: "
					+ e.getMessage());
		}
		try {
			if (mysql instanceof Connection) {
				mysqlStmt = mysql.createStatement();
				ecoHandler = new EconomyHandler(this);
			} else {
				LOGGER.severe("! * ! * ! * ! * !  --DynEco-- * ! * ! * ! * ! * ");
				LOGGER.severe(" - A link to your MySQL database could not be ");
				LOGGER.severe(" - established. Please check that it is running,");
				LOGGER.severe(" - and that your config is correct.");
				LOGGER.severe(" - ");
				LOGGER.severe(" - Plugin will now be disabled, and your default");
				LOGGER.severe(" - economy plugin will take control!");
				LOGGER.severe("! * ! * ! * ! * ! * ! * ! * ! * ! * ! * ! * ! * !");
				pm.disablePlugin(this);
			}

		} catch (SQLException e) {
			LOGGER.severe("[DynEco] MySQL error: " + e.getMessage());

		}

		try {
			if (ecoHandler instanceof EconomyHandler) {
				ecoHandler.databaseGarbageCollection();
				LOGGER.info("[DynEco] Automatic pruning of rows older than "
						+ this.getConfig().getInt("mysql.purge") + " days.");
				LOGGER.info("[DynEco] All systems are go.");
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	@Override
	public boolean onCommand(final CommandSender sender, final Command command,
			final String commandLabel, final String[] args) {
		try {
			commandHandler = new CommandHandler(this);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return commandHandler.handle(sender, command, commandLabel, args);
	}

	public YamlConfiguration getItemValues() {
		return itemValues;
	}

	public EconomyHandler getEconomyHandler() {
		return ecoHandler;
	}

	public ItemDb getItemDb() {
		return itemdb;
	}
}