package org.minecms.dyneco;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.Sign;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;

public class DynEcoPlayerListener implements Listener {

	EconomyHandler ecoHandler = null;
	DynEco dyneco;
	ItemDb itemdb;

	public DynEcoPlayerListener(DynEco dynEco) throws Exception {
		dyneco = dynEco;
		ecoHandler = new EconomyHandler(dyneco);
		if (!(ecoHandler instanceof EconomyHandler))
			throw new Exception("Could not get EconomyHandler");
		itemdb = dyneco.getItemDb();
	}

	/*
	 * [Buy] 10 dirt $5
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	public void onBlockInteraction(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		Block block = event.getClickedBlock();
		if (block.getType().equals(Material.WALL_SIGN)
				|| block.getType().equals(Material.SIGN_POST)) {
			Sign sign = (Sign) block.getState();
			String[] lines = sign.getLines();
			if (lines[0].contains("[buy]")) {
				if (!lines[1].isEmpty() && !lines[2].isEmpty()) {
					ItemStack stack = itemdb.get(lines[2]);
					stack.setAmount(Integer.valueOf(lines[1]));
					ecoHandler.buyStack(stack, player);
				}
				if (!lines[3].isEmpty()) {
					if (player.hasPermission("dyneco.notices") || player.isOp()) {
						player.sendMessage(ChatColor.YELLOW
								+ "It looks like this is a sign from another economy plugin.");
						player.sendMessage(ChatColor.YELLOW
								+ "While DynEco may still be able to use it, you should probably update it.");
						return;
					}
				}
			}
		}

	}

	@EventHandler(priority = EventPriority.HIGHEST)
	public void onBlockBreak(BlockBreakEvent event) {
		Player player = event.getPlayer();
		Block block = event.getBlock();
		if (block.getType().equals(Material.WALL_SIGN)
				|| block.getType().equals(Material.SIGN_POST)) {
			Sign sign = (Sign) block.getState();
			String[] lines = sign.getLines();
			if (lines[0].contains("[buy]")) {

				event.setCancelled(true);
				int i = 0;
				while (i < 4) {
					sign.setLine(i, lines[i]);
					i++;
				}
				player.sendMessage("Sign breakage was cancelled by DynEco");
			}
		}
	}

}
